Prov.Skill<-function(recipe,data,graph,type){
  #Define parameters
  i<-switch(type,
            "fcst"="parentnodename_fcst",
            "hcst"="parentnodename_hcst",
            "obs"="parentnodename_obs")
  parentnodename<-graph$parentnodename[[i]]
  reference.nodename<-graph$parentnodename$parentnodename_obs
  graph<-graph$graph
  measure <- recipe$Analysis$Workflow$Skill$metric
  if(type=="fcst" | type=="hcst"){
    #Verification node
    verification.nodename <- paste0("Verification_",type)
    graph <- add_vertices(graph,
                            nv = 1,
                            name = verification.nodename,
                            label="Verification",
                            className = "veri:ForecastVerification")
    # Linking the verification
    graph <- add_edges(graph, 
                        c(getNodeIndexbyName(graph, parentnodename),
                        getNodeIndexbyName(graph, verification.nodename)),
                        label = "veri:hadValidation")
    # Linking the verification with the observations
    graph <- add_edges(graph, 
                        c(getNodeIndexbyName(graph, reference.nodename),
                            getNodeIndexbyName(graph,verification.nodename)),
                        label = "veri:withReference")

    #Add Verification metrics
    measure <- unlist(strsplit(measure, " "))
    archive<-read_yaml("conf/variable-dictionary_provenance.yml")
    for(names in measure){
      metric<-tolower(names)
      if(metric %in% names(archive$metrics)){
        metric.method<-archive$metrics[[metric]]$long_name
        metric.class<-paste0("veri:",archive$metrics[[metric]]$representation)
        description<-archive$metrics[[metric]]$definition
      }else{
        stop("Downscaling method not registered or not properly defined")
      }

      metric.nodename<- paste0("Metrics_",type,"_",metric) 
      graph <- add_vertices(graph,
                            nv = 1,
                            name = metric.nodename,
                            label=metric.method,
                            className = metric.class,
                            attr=list("dc:title"=label.name, "dc:description"=description))
      graph <- add_edges(graph, 
                         c(getNodeIndexbyName(graph, metric.nodename),
                             getNodeIndexbyName(graph, verification.nodename)),
                         label = "veri:withForecastRepresentation")
    }
    print(paste0("Skill provenance computed for ",type))
    return(list("graph"=graph,"parentnodename"=verification.nodename))
     
  }else{
    print(paste0("Skill provenance computed for ",type))
    return(list("graph"=graph, "parentnodename"=parentnodename))
  }
}